'use strict';

const gulp = require('gulp');
const browserSync = require('browser-sync');
var sourcemaps = require('gulp-sourcemaps');

// Load plugins
const $ = require('gulp-load-plugins')();


gulp.task('default', [], function () {
    gulp.start('watch');
});
gulp.task('watch', ['build'], function () {
    gulp.watch('css/*.less', ['styles']);
    gulp.watch(['*.html','js/**/*.js'], {interval: 300}).on('change', browserSync.reload);
    gulp.start('browser-sync');
});
gulp.task('build', ['styles']);


gulp.task('styles', function () {
    var browsers = [
        '> 1%',
        'last 2 versions',
        'Firefox ESR',
        'Opera 12.1'
    ];
    return gulp.src('css/style.less')
      //  .pipe(sourcemaps.init())
        .pipe($.less({
            paths: ['bower_components','node_modules']
        })
            .on('error', $.util.log))
      //  .pipe(sourcemaps.write('.'))
        .pipe($.postcss([
            require('autoprefixer-core')({
                browsers: browsers
            })
        ]))
        .pipe(gulp.dest('css'))
        .pipe(browserSync.reload({stream: true}));
});

// gulp.task('views', function () {
//     return gulp.src([
//         'index.html',
//         '**/*.html',
//         '**/*.js'
//     ])
//         .pipe();
// });


gulp.task('browser-sync', function () {
    browserSync({
        server: {
            // baseDir: './build',
            // routes: {
            //     '/bower_components': 'bower_components',
            //     '/node_modules':'node_modules'
            // }
        },
        notify: {
            styles: {
                top: 'auto',
                bottom: '50%'
            }
        },
        ghostMode: {
            clicks: false,
            forms: false,
            scroll: false
        }
    });
});
