$(function() {
    firebase.auth().onAuthStateChanged(function(user) {
        if (user) {
            app.auth = user;
            console.log("LOGGEDIN");
        } else {
            console.log("SIGNED OUT");
        }
    });
});

var app = new Vue({
    el: '#app',
    data: {
        auth: {},
        signUpError: ""
    },
    methods: {
        signup: function() {
            app.signUpError = "";

            firebase.auth().createUserWithEmailAndPassword($("#signup-email").val(), $("#signup-password").val()).catch(function(error) {
                // Handle Errors here.
                app.signUpError = error.message;

                let errorCode = error.code;
                let errorMessage = error.message;
                // ...
            });
        },
        login: function() {
            app.signUpError = "";

            firebase.auth().setPersistence(firebase.auth.Auth.Persistence.SESSION).then(function() {
                // Existing and future Auth states are now persisted in the current
                // session only. Closing the window would clear any existing state even
                // if a user forgets to sign out.
                // ...
                // New sign-in will be persisted with session persistence.
                firebase.auth().signInWithEmailAndPassword($("#login-email").val(), $("#login-password").val()).then(function(aaa) {
                    console.log("YAY", aaa);
                    app.auth = aaa;
                }).catch(function(error) {
                    console.log("errror", error.message);
                });
            }).catch(function(error) {
                // Handle Errors here.
                // let errorCode = error.code;
                // let errorMessage = error.message;
                app.signUpError = error.message;
                console.log("errror", error.message);
            });
        },
        signout: function(){
            firebase.auth().signOut().then(function() {
                app.auth = {};
            }, function(error) {
                // An error happened.
            });
        }
    }
});
