$(function() {
    app.populateItems();
});
Vue.component('list-item', {
    template: '#listItem',
    props: ['item','id'],
    methods: {
        editItem: function(id,item) {
            this.$root.editItem(id,item);
        },
        deleteItem: function(id) {
            this.$root.deleteItem(id);
        }
    }
});
var app = new Vue({
    el: '#app',
    data: {
        addEditForm: 'Add',
        itemsList: {}
    },
    methods: {
        populateItems: function() {
            db.collection("items").onSnapshot(function(snapshot) {
                snapshot.docChanges.forEach(function(change) {
                    let data = change.doc.data();
                    if (change.type === "added") {
                        console.log("ADDED: ", data);
                        var newObj = {};
                        newObj[change.doc.id] = data;
                        app.itemsList = Object.assign({}, app.itemsList, newObj);
                    }
                    if (change.type === "modified") {
                        var newObj = {};
                        newObj[change.doc.id] = data;
                        app.itemsList = Object.assign({}, app.itemsList, newObj);
                        console.log("Modified: ", data);
                    }
                    if (change.type === "removed") {
                        console.log(change.doc.id, app.itemsList);
                        delete app.itemsList[change.doc.id];
                        app.itemsList = Object.assign({}, app.itemsList, app.itemsList);
                        console.log("Removed  ", data);
                    }
                });
                console.log(app.itemsList);
            });
        },
        addItem: function(objToAdd) {
            db.collection("items").add(objToAdd).then(function(doc) {
                console.log(doc, "added!");
            }).catch(function(error) {
                console.error("Error adding document: ", error);
            });
        },
        editItem: function(id, value) {
            app.itemBeingEditedId = id;
            app.addEditForm = 'Edit';
            $.each(value, function(key, value) {
                var ctrl = $('[name=' + key + ']', "#item-form");
                switch (ctrl.prop("type")) {
                    case "radio":
                    case "checkbox":
                        ctrl.each(function() {
                            if ($(this).attr('value') == value) 
                                $(this).attr("checked", value);
                            }
                        );
                        break;
                    default:
                        ctrl.val(value);
                }
            });
            UIkit.modal("#add-edit-modal").show();
        },
        updateItem: function(updateItem) {
            db.collection("items").doc(app.itemBeingEditedId).set(updateItem).then(function() {
                console.log("Document successfully updated!");
            }).catch(function(error) {
                console.error("Error updating: ", error);
            });
        },
        onSubmit: function(e) {
            var objToAdd = {};
            $.each($(e.target).serializeArray(), function(itemInd, itemVal) {
                objToAdd[itemVal.name] = itemVal.value;
            });
            // Move to the if below if you dont want edited items to appear at bottom
            objToAdd["date"] = Date.now();
            if (app.addEditForm === "Add") {
                app.addItem(objToAdd);
            } else {
                app.updateItem(objToAdd);
                app.addEditForm = "Add";
                app.itemBeingEditedId = false;
            }
            $(':input', e.target).not(':button, :submit, :reset, :hidden').val('').prop('checked', false).prop('selected', false);
            UIkit.modal("#add-edit-modal").hide();
        },
        deleteItem: function(itemId) {
            db.collection("items").doc(itemId).delete().then(function() {
                console.log("Document successfully deleted!");
            }).catch(function(error) {
                console.error("Error removing document: ", error);
            });
        },
        sortItems: function(items) {
            var newSorted = [];
            Object.keys(items).sort(function(a, b) {
                return items[a].date - items[b].date;
            }).forEach(function(key) {
                var newItem = {};
                newItem["id"] = key;
                newItem["value"] = items[key];
                newSorted.push(newItem);
            });
            console.log(newSorted);
            return newSorted;
        }
    }
});
