//https://firebase.google.com/docs/storage/web/upload-files
function guid() {
    function s4() {
        return Math.floor((1 + Math.random()) * 0x10000).toString(16).substring(1);
    }
    return s4() + s4() + '-' + s4() + '-' + s4() + '-' + s4() + '-' + s4() + s4() + s4();
}
$(function() {
    $("#click").on("click", function() {
        var filez = $('#fileInput').get(0).files;
        var file = filez.item(0);
        var filename = guid() + filez[0].name;
        var ref = storageRef.child(filename);
        ref.put(file).then(function(snapshot) {
            if (filename.split(".")[1] === "png" || filename.split(".")[1] === "jpg" || filename.split(".")[1] === "svg" || filename.split(".")[1] === "jpeg" || filename.split(".")[1] === "gif") {
                $("body").append("<img src='" + snapshot.downloadURL + "'>");
            }
            $("body").append("<code>" + snapshot.downloadURL + "</code>");
            snapshot.ref.getDownloadURL().then(function(downloadURL) {
                console.log('File available at', downloadURL);
            });
        });
    });
    function uploadFile(filez, file, filename, uploadTask) {
        // Listen for state changes, errors, and completion of the upload.
        uploadTask.on(firebase.storage.TaskEvent.STATE_CHANGED, // or 'state_changed'
                function(snapshot) {
            // Get task progress, including the number of bytes uploaded and the total number of bytes to be uploaded
            var progress = (snapshot.bytesTransferred / snapshot.totalBytes) * 100;
            console.log('Upload is ' + progress + '% done');

            bar.removeAttribute('hidden');
            bar.max = snapshot.totalBytes;
            bar.value = snapshot.bytesTransferred;
            switch (snapshot.state) {
                case firebase.storage.TaskState.PAUSED: // or 'paused'
                    console.log('Upload is paused');
                    break;
                case firebase.storage.TaskState.RUNNING: // or 'running'
                    console.log('Upload is running');
                    break;
            }
        }, function(error) {

            // A full list of error codes is available at
            // https://firebase.google.com/docs/storage/web/handle-errors
            console.error(error);
        }, function() {
            // Upload completed successfully, now we can get the download URL
            //
            if (filename.split(".")[1] === "png" || filename.split(".")[1] === "jpg" || filename.split(".")[1] === "svg" || filename.split(".")[1] === "jpeg") {
                $(".addImage").append('<div class="uk-card uk-background-cover" style="position:relative; width: 200px; height: 200px; background-image:url(' + uploadTask.snapshot.downloadURL + ');"><input class="link" style="position:absolute;left:0;top:100%;width: 200px;" value="' + uploadTask.snapshot.downloadURL + '" /></div>');
            } else {
                $("body").append("<code>" + uploadTask.snapshot.downloadURL + "</code>");
            }
            uploadTask.snapshot.ref.getDownloadURL().then(function(downloadURL) {
                console.log('File available at', downloadURL);
                bar.setAttribute('hidden', 'hidden');
            });
        });
    }
    $('.js-upload').on({
        'dragover dragenter': function(e) {
            e.preventDefault();
            e.stopPropagation();
            $(this).addClass("uk-dragover");
        },
        'drop': function(e) {
            //console.log(e.originalEvent instanceof DragEvent);
            var dataTransfer = e.originalEvent.dataTransfer;
            if (dataTransfer && dataTransfer.files.length) {
                $(this).removeClass("uk-dragover");
                e.preventDefault();
                e.stopPropagation();
                var filez = dataTransfer.files;
                var file = filez.item(0);
                var filename = guid() + filez[0].name;
                // ref.put(file).then(function(snapshot) {

                // });

                // Upload file and metadata to the object 'images/mountains.jpg'
                var uploadTask = storageRef.child('images/' + filename).put(file);
                uploadFile(filez, file, filename, uploadTask);
            }
        }
    });
    $('#upload22').on("change", function(e) {
        var filez = $('#upload22').get(0).files;
        var file = filez.item(0);
        var filename = guid() + filez[0].name;
        // ref.put(file).then(function(snapshot) {

        // });

        // Upload file and metadata to the object 'images/mountains.jpg'
        var uploadTask = storageRef.child('images/' + filename).put(file);
        uploadFile(filez, file, filename, uploadTask);
    });
});
